HDU 1003--DP(最大子序列和)

题意:一组数列,求子序列和的最大值以及首末位置。

分析:dp,转移方程是:dp[i]=max(dp[i-1]+a[i],dp[i])

这里要求记录序列的位置所以dp设为二维数组,dp[i][0]用来记录最优解的首位置,首位置用dp应该是这样的:如果发生了上面的状态转移则dp[i][0]=dp[i-1][0]

注意:题目要求如果有多种答案,输出第一种。所以i从1开始,dp[0][1]设为-2000,这样才能保证记录的末位置是从1开始的。

代码:

#include<iostream>
using namespace std;
int dp[100008][2],mx,index;
int t,n;
int DP()
{
	for(int i=1;i<=n;i++){
	    if(dp[i-1][1]>=0){
	   	   dp[i][1]+=dp[i-1][1];
		   dp[i][0]=dp[i-1][0];
		}
	    if(mx<dp[i][1]){
		    mx=dp[i][1];
		    index=i;
		}
	}
	return index;
}
int main()
{
	cin>>t;
	for(int i=1;i<=t;i++){
		cin>>n;
		dp[0][0]=0,dp[0][1]=-2000;
        for(int j=1;j<=n;j++){
		   cin>>dp[j][1];
		   dp[j][0]=j;
		 }
		 mx=-2000;
		 cout<<"Case "<<i<<":"<<endl;
		 int tp=DP();
		 cout<<dp[tp][1]<<" "<<dp[tp][0]<<" "<<tp<<endl;
		 if(i!=t) cout<<endl;
	}
} 
时间: 2024-10-12 15:54:50

HDU 1003--DP(最大子序列和)的相关文章

HDU 1003 最大连续子序列

看数据结构与算法分析Java语言描述的时间复杂度分析时,看到经典的最大子序列和问题,想起来这到以前用C++写过,现在学了Java试一下能不能AC. PS:不知为什么我前面用System.out.printf()函数一直输出格式错误,交了好几遍都不行,后来改成System.out.println()又可以了... 1 import java.util.Scanner; 2 3 public class Main { 4 5 public static void main(String[] args

[ An Ac a Day ^_^ ] hdu 1003 dp

超时还有可能是数组开小了…… 1 #include<stdio.h> 2 #include<iostream> 3 #include<algorithm> 4 #include<math.h> 5 #include<string.h> 6 #include<string> 7 #include<map> 8 #include<set> 9 #include<vector> 10 #include&l

HDU 1003 Max Sum(DP)

题目地址:HDU 1003 DP好弱..先补补DP的基础... 这题就是记录起始点与终止点,然后每当发现一个更大的,就更新.从左往右扫一遍就行了. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h> #include <ctype.h> #

HDU 1003 Max Sum(dp,最大连续子序列和)

Max Sum Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input

HDU 1231 最大连续子序列 --- 入门DP

HDU 1231 题目大意以及解题思路见: HDU 1003题解,此题和HDU 1003只是记录的信息不同,处理完全相同. /* HDU 1231 最大连续子序列 --- 入门DP */ #include <cstdio> #include <cstring> int dp[10005]; int main() { #ifdef _LOCAL freopen("D:\\input.txt", "r", stdin); #endif int n

【ToReadList】六种姿势拿下连续子序列最大和问题,附伪代码(以HDU 1003 1231为例)(转载)

问题描述:       连续子序列最大和,其实就是求一个序列中连续的子序列中元素和最大的那个. 比如例如给定序列: { -2, 11, -4, 13, -5, -2 } 其最大连续子序列为{ 11, -4, 13 },最大和为20. =============================================================== 问题分析: 1.首先最朴素的方法是暴力 O(n^3) 直接两个for循环枚举子序列的首尾,然后再来个循环计算序列的和,每次更新和的最大值.

HDU - 1003 - Max Sum &amp;&amp; POJ - 1050 - To the Max (经典DP问题)

题目传送:HDU - 1003 思路:最大子序列和 dp[i]= a[i]   (dp[i-1]<0) dp[i]= dp[i-1]+a[i]   (dp[i-1]>=0) AC代码: #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #include <cmath> #include <queue> #include

hdu 1231 最大连续子序列 DP

最大连续子序列 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 20633    Accepted Submission(s): 9151 Problem Description 给定K个整数的序列{ N1, N2, ..., NK },其任意连续子序列可表示为{ Ni, Ni+1, ..., Nj },其中 1 <= i <= j

HDU 1003 Max Sum 最大连续子序列的和

Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input contains

HDU 1231 最大连续子序列 DP题解

典型的DP题目,增加一个额外要求,输出子序列的开始和结尾的数值. 增加一个记录方法,nothing special. 记录最终ans的时候,同时记录开始和结尾下标: 更新当前最大值sum的时候,更新开始节点. const int MAX_N = 10001; long long arr[MAX_N]; int N, sta, end; long long getMaxSubs() { long long sum = 0, ans = LLONG_MIN; int ts = 0; for (int